#include "server_data_interact.h"
#include <engine_engine_number_9/baza_throw.h>

namespace iu9cawebchat {
    json::JSON internalapi_getChatList(SqliteConnection& conn, int64_t uid, const json::JSON& Sent) {
        json::JSON Recv;
        Recv["status"] = json::JSON(0l);
        Recv["chats"] = json::JSON(json::array);
        std::vector<json::JSON>& chats = Recv["chats"].g().asArray();
        SqliteStatement req(conn,
            "SELECT `chat`.`id`, `chat`.`nickname`, `chat`.`name`, `chat`.`lastMsgId`, "
            "`user_chat_membership`.`role` FROM `chat` "
            "RIGHT JOIN `user_chat_membership` ON `chat`.`id` = `user_chat_membership`.`chatId` "
            "WHERE `user_chat_membership`.`userId` = ?1 ", {{1, uid}}, {});
        while (true) {
            fsql_integer_or_null chat_id;
            fsql_text8_or_null chat_nickname, chat_name;
            fsql_integer_or_null chat_lastMsgId, role_here;
            int status = sqlite_stmt_step(req, {{0, &chat_id}, {3, &chat_lastMsgId}, {4, &role_here}},
                {{1, &chat_nickname}, {2, &chat_name}});
            if (status != SQLITE_ROW)
                break;
            chats.emplace_back();
            json::JSON& chat = chats.back();
            chat["id"] = json::JSON(chat_id.value);
            chat["content"]["nickname"] = json::JSON(chat_nickname.value);
            chat["content"]["name"] = json::JSON(chat_name.value);
            chat["content"]["lastMsgId"] = json::JSON(chat_lastMsgId.exist ? chat_lastMsgId.value : -1);
            chat["content"]["roleHere"] = json::JSON(stringify_user_chat_role(role_here.value));
        }
        return Recv;
    }
}
